
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# provide meta-data
set(reflective_rapidjson_varname "REFLECTIVE_RAPIDJSON")
set(reflective_rapidjson_static_varname "REFLECTIVE_RAPIDJSON")
set(REFLECTIVE_RAPIDJSON_DISPLAY_NAME "Reflection for RapidJSON")
set(REFLECTIVE_RAPIDJSON_AUTHOR "Martchus")
set(REFLECTIVE_RAPIDJSON_VERSION "0.0.4")
set(REFLECTIVE_RAPIDJSON_VERSION_MAJOR "0")
set(REFLECTIVE_RAPIDJSON_VERSION_MINOR "0")
set(REFLECTIVE_RAPIDJSON_VERSION_PATCH "4")
set(REFLECTIVE_RAPIDJSON_GIT_REV_COUNT "")
set(REFLECTIVE_RAPIDJSON_GIT_LAST_COMMIT_ID "")
set(REFLECTIVE_RAPIDJSON_URL "https://github.com/Martchus/reflective_rapidjson")
set(REFLECTIVE_RAPIDJSON_DESCRIPTION "Reflection for serializing/deserializing with RapidJSON")

# define general config
set(REFLECTIVE_RAPIDJSON_IS_HEADER_ONLY YES)
set(REFLECTIVE_RAPIDJSON_HAS_SHARED_LIB ON)
set(REFLECTIVE_RAPIDJSON_HAS_STATIC_LIB ON)
set(REFLECTIVE_RAPIDJSON_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include")
set(REFLECTIVE_RAPIDJSON_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin")
set(REFLECTIVE_RAPIDJSON_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib")
set(REFLECTIVE_RAPIDJSON_MODULE_DIRS "${PACKAGE_PREFIX_DIR}/share/reflective_rapidjson/cmake/modules")
set(REFLECTIVE_RAPIDJSON_CONFIG_DIRS "${PACKAGE_PREFIX_DIR}/share/reflective_rapidjson/cmake")
set(REFLECTIVE_RAPIDJSON_PRIVATE_QT_MODULES "")
set(REFLECTIVE_RAPIDJSON_PRIVATE_KF_MODULES "")
set(REFLECTIVE_RAPIDJSON_PUBLIC_QT_MODULES "")
set(REFLECTIVE_RAPIDJSON_PUBLIC_KF_MODULES "")
set(REFLECTIVE_RAPIDJSON_HAS_QT_TRANSLATION_FILES )
set(REFLECTIVE_RAPIDJSON_QT_RESOURCES )

# define shared library config
if(REFLECTIVE_RAPIDJSON_HAS_SHARED_LIB)
    set(REFLECTIVE_RAPIDJSON_SHARED_LIB "reflective_rapidjson")
    set(REFLECTIVE_RAPIDJSON_SHARED_LIB_DEPENDS )
    set(REFLECTIVE_RAPIDJSON_SHARED_LIB_COMPILE_DEFINITIONS )
    set(PC_PKG_SHARED_reflective_rapidjson "reflective_rapidjson")
    if(NOT TARGET "${REFLECTIVE_RAPIDJSON_SHARED_LIB}")
        include("${CMAKE_CURRENT_LIST_DIR}/reflective_rapidjsonSharedTargets.cmake")
    endif()
endif()

# define static library config
if(REFLECTIVE_RAPIDJSON_HAS_STATIC_LIB)
    set(REFLECTIVE_RAPIDJSON_STATIC_LIB "reflective_rapidjson_static")
    set(REFLECTIVE_RAPIDJSON_STATIC_LIB_DEPENDS  )
    set(REFLECTIVE_RAPIDJSON_STATIC_LIB_COMPILE_DEFINITIONS REFLECTIVE_RAPIDJSON_STATIC)
    set(PC_PKG_STATIC_reflective_rapidjson_static "reflective_rapidjson_static")
    if(NOT TARGET "${REFLECTIVE_RAPIDJSON_STATIC_LIB}")
        include("${CMAKE_CURRENT_LIST_DIR}/reflective_rapidjsonStaticTargets.cmake")
    endif()
endif()

# set default target: prefer shared lib over static lib
if(REFLECTIVE_RAPIDJSON_HAS_SHARED_LIB)
    set(REFLECTIVE_RAPIDJSON_LIB "reflective_rapidjson")
else()
    set(REFLECTIVE_RAPIDJSON_LIB "reflective_rapidjson_static")
endif()

# define macro to ease use of library
macro(use_reflective_rapidjson)
    # make CMake modules of the project available
    list(APPEND CMAKE_MODULE_PATH ${REFLECTIVE_RAPIDJSON_MODULE_DIRS})
    # link against library (also "link" against header-only libs to get compile defs and interface link libs)
    link_directories(${REFLECTIVE_RAPIDJSON_LIB_DIR})
    include(3rdParty)
    if(NOT ARGV0)
        set(REFLECTIVE_RAPIDJSON_LINKAGE AUTO_LINKAGE)
    else()
        set(REFLECTIVE_RAPIDJSON_LINKAGE "${ARG0}")
    endif()
    link_against_library(REFLECTIVE_RAPIDJSON "${REFLECTIVE_RAPIDJSON_LINKAGE}" REQUIRED)
    # add required Qt and KF modules
    list(APPEND IMPORTED_QT_MODULES
        ${REFLECTIVE_RAPIDJSON_PUBLIC_QT_MODULES}
        ${REFLECTIVE_RAPIDJSON_PRIVATE_QT_MODULES}
    )
    list(APPEND IMPORTED_KF_MODULES
        ${REFLECTIVE_RAPIDJSON_PUBLIC_KF_MODULES}
        ${REFLECTIVE_RAPIDJSON_PRIVATE_KF_MODULES}
    )
    # add required translations to APP_SPECIFIC_QT_TRANSLATION_FILES_ARRAY
    if(REFLECTIVE_RAPIDJSON_HAS_QT_TRANSLATION_FILES)
        list(APPEND APP_SPECIFIC_QT_TRANSLATION_FILES reflective_rapidjson)
    endif()
endmacro()
